// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/predicate"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// TermQuery is the builder for querying Term entities.
type TermQuery struct {
	config
	ctx             *QueryContext
	order           []term.OrderOption
	inters          []Interceptor
	predicates      []predicate.Term
	withDefinitions *DefinitionQuery
	modifiers       []func(*sql.Selector)
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the TermQuery builder.
func (tq *TermQuery) Where(ps ...predicate.Term) *TermQuery {
	tq.predicates = append(tq.predicates, ps...)
	return tq
}

// Limit the number of records to be returned by this query.
func (tq *TermQuery) Limit(limit int) *TermQuery {
	tq.ctx.Limit = &limit
	return tq
}

// Offset to start from.
func (tq *TermQuery) Offset(offset int) *TermQuery {
	tq.ctx.Offset = &offset
	return tq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (tq *TermQuery) Unique(unique bool) *TermQuery {
	tq.ctx.Unique = &unique
	return tq
}

// Order specifies how the records should be ordered.
func (tq *TermQuery) Order(o ...term.OrderOption) *TermQuery {
	tq.order = append(tq.order, o...)
	return tq
}

// QueryDefinitions chains the current query on the "definitions" edge.
func (tq *TermQuery) QueryDefinitions() *DefinitionQuery {
	query := (&DefinitionClient{config: tq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := tq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := tq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(term.Table, term.FieldID, selector),
			sqlgraph.To(definition.Table, definition.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, term.DefinitionsTable, term.DefinitionsColumn),
		)
		fromU = sqlgraph.SetNeighbors(tq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Term entity from the query.
// Returns a *NotFoundError when no Term was found.
func (tq *TermQuery) First(ctx context.Context) (*Term, error) {
	nodes, err := tq.Limit(1).All(setContextOp(ctx, tq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{term.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (tq *TermQuery) FirstX(ctx context.Context) *Term {
	node, err := tq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Term ID from the query.
// Returns a *NotFoundError when no Term ID was found.
func (tq *TermQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = tq.Limit(1).IDs(setContextOp(ctx, tq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{term.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (tq *TermQuery) FirstIDX(ctx context.Context) int {
	id, err := tq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Term entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Term entity is found.
// Returns a *NotFoundError when no Term entities are found.
func (tq *TermQuery) Only(ctx context.Context) (*Term, error) {
	nodes, err := tq.Limit(2).All(setContextOp(ctx, tq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{term.Label}
	default:
		return nil, &NotSingularError{term.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (tq *TermQuery) OnlyX(ctx context.Context) *Term {
	node, err := tq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Term ID in the query.
// Returns a *NotSingularError when more than one Term ID is found.
// Returns a *NotFoundError when no entities are found.
func (tq *TermQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = tq.Limit(2).IDs(setContextOp(ctx, tq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{term.Label}
	default:
		err = &NotSingularError{term.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (tq *TermQuery) OnlyIDX(ctx context.Context) int {
	id, err := tq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Terms.
func (tq *TermQuery) All(ctx context.Context) ([]*Term, error) {
	ctx = setContextOp(ctx, tq.ctx, "All")
	if err := tq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Term, *TermQuery]()
	return withInterceptors[[]*Term](ctx, tq, qr, tq.inters)
}

// AllX is like All, but panics if an error occurs.
func (tq *TermQuery) AllX(ctx context.Context) []*Term {
	nodes, err := tq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Term IDs.
func (tq *TermQuery) IDs(ctx context.Context) (ids []int, err error) {
	if tq.ctx.Unique == nil && tq.path != nil {
		tq.Unique(true)
	}
	ctx = setContextOp(ctx, tq.ctx, "IDs")
	if err = tq.Select(term.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (tq *TermQuery) IDsX(ctx context.Context) []int {
	ids, err := tq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (tq *TermQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, tq.ctx, "Count")
	if err := tq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, tq, querierCount[*TermQuery](), tq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (tq *TermQuery) CountX(ctx context.Context) int {
	count, err := tq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (tq *TermQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, tq.ctx, "Exist")
	switch _, err := tq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (tq *TermQuery) ExistX(ctx context.Context) bool {
	exist, err := tq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the TermQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (tq *TermQuery) Clone() *TermQuery {
	if tq == nil {
		return nil
	}
	return &TermQuery{
		config:          tq.config,
		ctx:             tq.ctx.Clone(),
		order:           append([]term.OrderOption{}, tq.order...),
		inters:          append([]Interceptor{}, tq.inters...),
		predicates:      append([]predicate.Term{}, tq.predicates...),
		withDefinitions: tq.withDefinitions.Clone(),
		// clone intermediate query.
		sql:  tq.sql.Clone(),
		path: tq.path,
	}
}

// WithDefinitions tells the query-builder to eager-load the nodes that are connected to
// the "definitions" edge. The optional arguments are used to configure the query builder of the edge.
func (tq *TermQuery) WithDefinitions(opts ...func(*DefinitionQuery)) *TermQuery {
	query := (&DefinitionClient{config: tq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	tq.withDefinitions = query
	return tq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Term.Query().
//		GroupBy(term.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (tq *TermQuery) GroupBy(field string, fields ...string) *TermGroupBy {
	tq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &TermGroupBy{build: tq}
	grbuild.flds = &tq.ctx.Fields
	grbuild.label = term.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.Term.Query().
//		Select(term.FieldCreatedAt).
//		Scan(ctx, &v)
func (tq *TermQuery) Select(fields ...string) *TermSelect {
	tq.ctx.Fields = append(tq.ctx.Fields, fields...)
	sbuild := &TermSelect{TermQuery: tq}
	sbuild.label = term.Label
	sbuild.flds, sbuild.scan = &tq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a TermSelect configured with the given aggregations.
func (tq *TermQuery) Aggregate(fns ...AggregateFunc) *TermSelect {
	return tq.Select().Aggregate(fns...)
}

func (tq *TermQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range tq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, tq); err != nil {
				return err
			}
		}
	}
	for _, f := range tq.ctx.Fields {
		if !term.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if tq.path != nil {
		prev, err := tq.path(ctx)
		if err != nil {
			return err
		}
		tq.sql = prev
	}
	return nil
}

func (tq *TermQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Term, error) {
	var (
		nodes       = []*Term{}
		_spec       = tq.querySpec()
		loadedTypes = [1]bool{
			tq.withDefinitions != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Term).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Term{config: tq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if len(tq.modifiers) > 0 {
		_spec.Modifiers = tq.modifiers
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, tq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := tq.withDefinitions; query != nil {
		if err := tq.loadDefinitions(ctx, query, nodes,
			func(n *Term) { n.Edges.Definitions = []*Definition{} },
			func(n *Term, e *Definition) { n.Edges.Definitions = append(n.Edges.Definitions, e) }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (tq *TermQuery) loadDefinitions(ctx context.Context, query *DefinitionQuery, nodes []*Term, init func(*Term), assign func(*Term, *Definition)) error {
	fks := make([]driver.Value, 0, len(nodes))
	nodeids := make(map[int]*Term)
	for i := range nodes {
		fks = append(fks, nodes[i].ID)
		nodeids[nodes[i].ID] = nodes[i]
		if init != nil {
			init(nodes[i])
		}
	}
	query.withFKs = true
	query.Where(predicate.Definition(func(s *sql.Selector) {
		s.Where(sql.InValues(s.C(term.DefinitionsColumn), fks...))
	}))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		fk := n.term_definitions
		if fk == nil {
			return fmt.Errorf(`foreign-key "term_definitions" is nil for node %v`, n.ID)
		}
		node, ok := nodeids[*fk]
		if !ok {
			return fmt.Errorf(`unexpected referenced foreign-key "term_definitions" returned %v for node %v`, *fk, n.ID)
		}
		assign(node, n)
	}
	return nil
}

func (tq *TermQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := tq.querySpec()
	if len(tq.modifiers) > 0 {
		_spec.Modifiers = tq.modifiers
	}
	_spec.Node.Columns = tq.ctx.Fields
	if len(tq.ctx.Fields) > 0 {
		_spec.Unique = tq.ctx.Unique != nil && *tq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, tq.driver, _spec)
}

func (tq *TermQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(term.Table, term.Columns, sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt))
	_spec.From = tq.sql
	if unique := tq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if tq.path != nil {
		_spec.Unique = true
	}
	if fields := tq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, term.FieldID)
		for i := range fields {
			if fields[i] != term.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := tq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := tq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := tq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := tq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (tq *TermQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(tq.driver.Dialect())
	t1 := builder.Table(term.Table)
	columns := tq.ctx.Fields
	if len(columns) == 0 {
		columns = term.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if tq.sql != nil {
		selector = tq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if tq.ctx.Unique != nil && *tq.ctx.Unique {
		selector.Distinct()
	}
	for _, m := range tq.modifiers {
		m(selector)
	}
	for _, p := range tq.predicates {
		p(selector)
	}
	for _, p := range tq.order {
		p(selector)
	}
	if offset := tq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := tq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// Modify adds a query modifier for attaching custom logic to queries.
func (tq *TermQuery) Modify(modifiers ...func(s *sql.Selector)) *TermSelect {
	tq.modifiers = append(tq.modifiers, modifiers...)
	return tq.Select()
}

// TermGroupBy is the group-by builder for Term entities.
type TermGroupBy struct {
	selector
	build *TermQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (tgb *TermGroupBy) Aggregate(fns ...AggregateFunc) *TermGroupBy {
	tgb.fns = append(tgb.fns, fns...)
	return tgb
}

// Scan applies the selector query and scans the result into the given value.
func (tgb *TermGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, tgb.build.ctx, "GroupBy")
	if err := tgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*TermQuery, *TermGroupBy](ctx, tgb.build, tgb, tgb.build.inters, v)
}

func (tgb *TermGroupBy) sqlScan(ctx context.Context, root *TermQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(tgb.fns))
	for _, fn := range tgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*tgb.flds)+len(tgb.fns))
		for _, f := range *tgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*tgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := tgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// TermSelect is the builder for selecting fields of Term entities.
type TermSelect struct {
	*TermQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ts *TermSelect) Aggregate(fns ...AggregateFunc) *TermSelect {
	ts.fns = append(ts.fns, fns...)
	return ts
}

// Scan applies the selector query and scans the result into the given value.
func (ts *TermSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ts.ctx, "Select")
	if err := ts.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*TermQuery, *TermSelect](ctx, ts.TermQuery, ts, ts.inters, v)
}

func (ts *TermSelect) sqlScan(ctx context.Context, root *TermQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ts.fns))
	for _, fn := range ts.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ts.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ts.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// Modify adds a query modifier for attaching custom logic to queries.
func (ts *TermSelect) Modify(modifiers ...func(s *sql.Selector)) *TermSelect {
	ts.modifiers = append(ts.modifiers, modifiers...)
	return ts
}
